{*C*H*I*P****S*P*E*C*I*A*L***** U N I T **********************************}
{(c) BE/tss                                                               }

UNIT Cursor;
{    Prozeduren zur Cursormanipulation                                    }

INTERFACE
USES Dos;

PROCEDURE CursorOn;
{    schaltet den Cursor an.                                              }

PROCEDURE CursorOff;
{    schaltet den Cursor ab.                                              }

PROCEDURE RestoreCursor;
{    setzt den Cusor auf die Form, die er beim Programmstart hatte        }

PROCEDURE CursorForm(oben, unten : byte);
{    ndert die die Cursorgre                                           }

PROCEDURE SaveCursorForm(VAR oben, unten : byte);
{    Sichert die aktuelle Cursorform den Parametern 'oben' und 'unten'    }

{*C*H*I*P****S*P*E*C*I*A*L************************************************}

IMPLEMENTATION

VAR   CursOben,
      CursObenSaved,
      CursUnten,
      CursUntenSaved : byte;

PROCEDURE SaveCursorForm(VAR oben, unten : byte);
  VAR R : Registers;
  begin
    R.AH:=3; Intr($10,R);
    oben:=R.CH; unten:=R.CL;
  end;

Procedure CursorOff;
  VAR R : Registers;
  begin
    R.AH:=1; R.CH:=15; R.CL:=0; Intr($10,R);
  end;

Procedure CursorOn;
  VAR R : Registers;
  begin
    R.AH:=1; R.CH:=CursOben; R.CL:=CursUnten;
    Intr($10,R);
  end;

Procedure RestoreCursor;
  VAR R : Registers;
  begin
    R.AH:=1; R.CH:=CursObenSaved; R.CL:=CursUntenSaved;
    CursOben:=CursObenSaved;
    CursUnten:=CursUntenSaved;
    Intr($10,R);
  end;

Procedure CursorForm(Oben, Unten : byte);
  VAR R : Registers;
  begin
    R.AH:=1; R.CH:=Oben; R.CL:=Unten;
    CursOben:=Oben; CursUnten:=Unten;
    Intr($10,R);
  end;

begin
  SaveCursorForm(CursOben, CursUnten);
  CursObenSaved:=CursOben;
  CursUntenSaved:=CursUnten;
end.
