program LPTFCNEU;

{ Hilfsprogramm zur Ansteuerung der Daten-, Steuer- und Statusleitungen
  des LPT-Interfaces ber die parallele Schnittstelle

  CopyRight Helmut Berka, DL2MAJ, Dornbuschweg 11, 86836 Obermeitingen
  All Rights Reserved - Nichtkommerzielle Nutzung im Amateurfunk gestattet }

uses DOS, CRT, PRINTER, SUPPORT, CURSOR, LPTUNIT;

var Steuerchar                      : integer;
    ch                              : char;
    Ende, Start                     : boolean;
    Schleifenzeit                   : real;
    DataIn, DataInLSB, DataInMSB    : byte;


procedure AUSGABE;

var DataOutStr  : str8;

begin
   DISP(4,3,HIGH,'D',0);
   DISPR(22,3,LOW,LPT,2,0);
   DISP(5,3,LOW,'atenbyteinhalt LPT',0);
   DISP(24,3,LOW,':',0);
   DISP(17,4,LOW,'D7 D6 D5 D4 D3 D2 D1 D0',0);
   DISP(4,5,LOW,'$' + ByteToHex(DatReg),4);
   DISP(8,5,LOW,DEZBIN(DatReg),0);
   for j:=1 to 8 do DISPZUSTAND(41-j*3,5,LOW,BITPEGEL(DatReg,NINV,j-1));

   DISP(42,3,LOW,'Datenbyte Interface Out:',0);
   DISP(55,4,LOW,'D7 D6 D5 D4 D3 D2 D1 D0',0);
   if AUTOFEEDPEGEL = lo
      then
         begin
            DISP(42,5,LOW,'$' + ByteToHex(DatReg),0);
            DISP(46,5,LOW,DEZBIN(DatReg),0);
            for j:=1 to 8 do DISPZUSTAND(79-j*3,5,LOW,BITPEGEL(DatReg,NINV,j-1));
         end
      else DISP(42,5,LOW,'$XX XXXXXXXX ** ** ** ** ** ** ** **',0);

   DISP(4,6,LOW,'Adressbyte:   $',0);
   DISP(3,7,LOW,' Ŀ   Ŀ',0);
   DISP(66, 7,LOW,'',0);
   DISP(66, 8,LOW,'',0);
   DISP(66, 9,LOW,'',0);
   DISP(66,10,LOW,'',0);
   DISP(68,8,LOW,'A3 A2 A1 A0',0);

   DISP(3,8,LOW,'nix Sel Sel Sel Sel Sel Sel Sel Sel Sel Sel Sel Sel Sel Sel Sel',0);
   DISP(4,9,LOW,'    14  13  12  11  10  9   8   7   6   5   4   3   2   1   0',0);

   { Die folgende Umformung ist erforderlich, da
     D4 .. D7 ber Kreuz mit A3 .. A0 verbunden sind!            }

   DataOutStr := DEZBIN(AdrOut shr 4 and $0F);
      { D7 .. D4 nach D3 .. D0 schieben, und mit $0F UND-verknpfen }

   ChipSelect := $00;
      { ChipSelect definiert setzen (auf $00) }

   if copy(DataOutStr,5,1) = '1' then ChipSelect := ChipSelect + 1;
      { D3 auf A0 umsetzen, A0 ist Stelle 2Hoch0, d.h. zhlt 1 }

   if copy(DataOutStr,6,1) = '1' then ChipSelect := ChipSelect + 2;
      { D2 auf A1 umsetzen, A1 ist Stelle 2Hoch1, d.h. zhlt 2 }

   if copy(DataOutStr,7,1) = '1' then ChipSelect := ChipSelect + 4;
      { D1 auf A2 umsetzen, A2 ist Stelle 2Hoch2, d.h. zhlt 4 }

   if copy(DataOutStr,8,1) = '1' then ChipSelect := ChipSelect + 8;
      { D0 auf A3 umsetzen, A3 ist Stelle 2Hoch3, d.h. zhlt 8 }

{   DISPR(3,9,HIGH,ChipSelect,3,0);  { Anzeige zu Programm-Test-Zwecken }
{   DISP(50,4,HIGH,DEZBIN(AdrOut),0);  { Anzeige zu Programm-Test-Zwecken }

   if Start
      then begin  { wird nur aktiviert, bis InitPegel zum 1. mal auf HI geht }
              DISP(28,6,LOW,'X',0);
              DISP(73,6,LOW,'X',0);
              for j:=1 to 4 do DISP(80-j*3,10,LOW,'XX',0);
              DISP(4,10,LOW,'**  **  **  **  **  **  **  **  **  **  **  **  **  **  **  **',0);
           end
      else begin
              DISP(28,6,LOW,copy(ByteToHex(AdrOut),1,1),0);
              DISP(73,6,LOW,copy(ByteToHex(AdrOut),2,1),0);
              for j:=1 to 4 do DISPZUSTAND(80-j*3,10,LOW,BITPEGEL(AdrOut,NINV,j-1));
              DISP(4,10,LOW,'HI  HI  HI  HI  HI  HI  HI  HI  HI  HI  HI  HI  HI  HI  HI  HI',0);
              DISP(64-ChipSelect*4,10,HIGH,'lo',0);
           end;

end;
{ ------------------------------------------------------------------------- }



procedure STEUERREG;

begin
   DISP(3,14,LOW,'Controlbyte',0);
   DISP(3,15,LOW,'$'+ByteToHex(CtrlReg),0);
   DISP(7,15,LOW,DEZBIN(CtrlReg),0);
   DISP(18,13,LOW,'______',0);
   DISP(18,14,HIGH,'S',0);
   DISP(19,14,LOW,'trobe',0);
   DISPZUSTAND(20,15,LOW,STROBEPEGEL);             { /Strobe-Pegel! }
   DISP(31,13,LOW,'________',0);
   DISP(31,14,HIGH,'A',0);
   DISP(32,14,LOW,'utofeed',0);
   DISPZUSTAND(34,15,LOW,AUTOFEEDPEGEL);           { /AutoFeed-Pegel! }
   DISP(44,14,HIGH,'I',0);
   DISP(45,14,LOW,'nit',0);
   DISPZUSTAND(45,15,LOW,INITPEGEL);               { Init-Pegel! }
   DISP(57,13,LOW,'______',0);
   DISP(57,14,LOW,'S CTIN',0);
   DISP(58,14,HIGH,'L',0);
   DISPZUSTAND(59,15,LOW,SLCTINPEGEL);             { /SLCTIN-Pegel! }
   DISP(70,14,LOW,'I Qenable',0);
   DISP(71,14,HIGH,'R',0);
   DISPZUSTAND(73,15,LOW,IRQENABLEPEGEL);          { IRQEnable-Pegel! }
end;
{ ------------------------------------------------------------------------- }


procedure EINGABE;

begin
   if SLCTINPEGEL = lo
      then DataInLSB := (port[StatRegAdr] shr 4) and $0F
      else DataInMSB := port[StatRegAdr] and $F0;

   DataIn := DataInMSB + DataInLSB;
   DISP(41,19,LOW,'Byte input',0);
   DISP(54,19,LOW,'D7 D6 D5 D4 D3 D2 D1 D0',0);

   if SLCTINPEGEL = lo
      then DISP(49,20,LOW,copy(DEZBIN(DataInLSB),5,4),0)
      else DISP(45,20,LOW,copy(DEZBIN(DataInMSB),1,4),0);
   DISP(41,20,LOW,'$' + ByteToHex(DataIn),0);
   for j := 1 to 8 do DISPZUSTAND(78-j*3,20,LOW,BITPEGEL(DataIn,NINV,j-1));

   DISP(25,19,LOW,'ERROR',0);
   DISPZUSTAND(27,20,LOW,BITPEGEL(port[StatRegAdr],NINV,3));
end;
{ ------------------------------------------------------------------------- }


procedure FORMULAR;

begin
     RAHMEN(1,1,80,24,INV,false);          { Titel }
     DISP(12,1,INV,'   Testprogramm fr LPT-Interface   ',0);
     DISP(62,1,LOW,' c DL2MAJ 1998 ',0);

     RAHMEN(2,2,79,11,HIGH,false);           { Rahmen fr Ausgabe }
     DISP(8,2,HIGH,' Ausgabe (Datenregister) ',0);

     RAHMEN(2,12,79,16,HIGH,false);         { Rahmen fr Steuerregister }
     DISP(8,12,HIGH,' Controlregister ',0);

     RAHMEN(2,17,79,23,HIGH,false);         { Rahmen fr Einlesen }
     DISP(8,17,HIGH,' Eingabe (Statusregister) ',0);

     AUSGABE;
     STEUERREG;
     EINGABE;

     DISP(5,22,LOW,'<F1> Hilfe',74);
     DISP(35,22,LOW,'<F5> Test',0);
     DISP(67,22,LOW,'<F10> Ende',0);
     DISP(72,23,LOW,' LPT  ',0);
     DISPR(76,23,LOW,LPT,2,0);
end;
{ ------------------------------------------------------------------------- }


procedure STROBE;

begin
   if STROBEPEGEL = lo
      then CtrlReg := CtrlReg - 1
      else CtrlReg := CtrlReg + 1;
end;
{ ------------------------------------------------------------------------- }


procedure AUTOFEED;

begin
   if AUTOFEEDPEGEL = lo
      then CtrlReg := CtrlReg - 2
      else CtrlReg := CtrlReg + 2;
end;
{ ------------------------------------------------------------------------- }


procedure INIT;

var INITPegelAlt : Pegel;

begin
   INITPegelAlt := INITPEGEL;
   if INITPEGEL = lo
      then CtrlReg := CtrlReg + 4
      else CtrlReg := CtrlReg - 4;
   if ((INITPegelAlt = lo) and (INITPEGEL = HI)) then
      begin
         AdrOut := DatReg;
         Start := false;
      end;
end;
{ ------------------------------------------------------------------------- }


procedure SLCTIN;

begin
   if SLCTINPEGEL = lo
      then CtrlReg := CtrlReg - 8
      else CtrlReg := CtrlReg + 8;
end;
{ ------------------------------------------------------------------------- }


procedure IRQENABLE;

begin
   if IRQENABLEPEGEL = lo
      then CtrlReg := CtrlReg + 16
      else CtrlReg := CtrlReg - 16;
end;
{ ------------------------------------------------------------------------- }


procedure DATAneu;

var DatRegInt, SteuerZ   : integer;

begin
   DISP( 4,3, LOW,'D',0);
   DISP( 9,3,HIGH,'b',0);
   DISP(18,4,HIGH,'7',0);
   DISP(21,4,HIGH,'6',0);
   DISP(24,4,HIGH,'5',0);
   DISP(27,4,HIGH,'4',0);
   DISP(30,4,HIGH,'3',0);
   DISP(33,4,HIGH,'2',0);
   DISP(36,4,HIGH,'1',0);
   DISP(39,4,HIGH,'0',0);

   repeat until keypressed;

   ch := readkey;
   Steuerchar := 0;
   if ch = #0 then   { Sondertaste, z. B. Funktionstaste }

   begin
      ch := readkey;
      Steuerchar := -ord(ch)
   end

   else  Steuerchar := +ord(ch);

   case Steuerchar of
            48 : if BITPEGEL(DatReg,NINV,0) = lo       { Taste 0 }
                    then DatReg := DatReg + 1
                    else DatReg := DatReg - 1;
            49 : if BITPEGEL(DatReg,NINV,1) = lo       { Taste 1 }
                    then DatReg := DatReg + 2
                    else DatReg := DatReg - 2;
            50 : if BITPEGEL(DatReg,NINV,2) = lo       { Taste 2 }
                    then DatReg := DatReg + 4
                    else DatReg := DatReg - 4;
            51 : if BITPEGEL(DatReg,NINV,3) = lo       { Taste 3 }
                    then DatReg := DatReg + 8
                    else DatReg := DatReg - 8;
            52 : if BITPEGEL(DatReg,NINV,4) = lo       { Taste 4 }
                    then DatReg := DatReg + 16
                    else DatReg := DatReg - 16;
            53 : if BITPEGEL(DatReg,NINV,5) = lo       { Taste 5 }
                    then DatReg := DatReg + 32
                    else DatReg := DatReg - 32;
            54 : if BITPEGEL(DatReg,NINV,6) = lo       { Taste 6 }
                    then DatReg := DatReg + 64
                    else DatReg := DatReg - 64;
            55 : if BITPEGEL(DatReg,NINV,7) = lo       { Taste 7 }
                    then DatReg := DatReg + 128
                    else DatReg := DatReg - 128;

       66,  98 : begin                       { Taste b }
                    DatRegInt := DatReg;
                    DISP(4,4,HIGH,'dezimal:',0);
                    CURSORON;
                    LIESINT(12,4,4,HIGH,DatRegInt,SteuerZ);
                    DatReg := DatRegInt;
                    DISP(4,4,LOW,' ',12);
                 end;
   end;
end;
{ ------------------------------------------------------------------------- }


procedure HILFE;

begin
   clrscr;
   DISP(2,1,LOW,'Die Inhalte der Register werden mit log. 0 bzw. log. 1 dargestellt,',0);
   DISP(2,2,LOW,'die an der Schnittstelle mebaren bzw. anliegenden Signale werden',0);
   DISP(2,3,LOW,'als lo bzw. HI-Pegel (entspricht niedriger bzw. hoher Spannung)',0);
   DISP(2,4,LOW,'angezeigt. Invertierte Signale sind durch einen Querstrich oberhalb',0);
   DISP(2,5,LOW,'des Signalnamens gekennzeichnet.',0);

   DISP(2,6,LOW,'Eine bitweise Vernderung (Invertierung) der Registerinhalte wird durch',0);
   DISP(2,7,LOW,'Eingabe des fett gedruckten Zeichens erreicht. Das Datenregister kann',0);
   DISP(2,8,LOW,'nach Eingabe von D und b durch einen Dezimalwert byteweise als auch durch',0);
   DISP(2,9,LOW,'Eingabe von D und 0 .. 7 bitweise verndert werden.',0);

   DISP(2,10,LOW,'Im Control- und Statusregister sind nicht alle Bits belegt, beim Ein-',0);
   DISP(2,11,LOW,'lesen bzw. bei der Ausgabe werden die unbenutzten Bits (Control-',0);
   DISP(2,12,LOW,'register D7 .. D5, Statusregister D2 .. D0) mit log. 0 belegt (durch',0);
   DISP(2,13,LOW,'UND-Verknpfung mit $1F bzw. $F8).',0);
   DISP(2,14,LOW,'Eine Sonderstellung nimmt D4 des Controlregisters ein. Diesem Bit ist keine',0);
   DISP(2,15,LOW,'Leitung am Schnittstellenausgang zugeordnet. Der Inhalt bestimmt, ob ber die',0);
   DISP(2,16,LOW,'Acknowledge-Leitung eine Interruptanforderung ausgelst werden darf',0);
   DISP(2,17,LOW,'(log. 1 = Yes, log. 0 = No).',0);

   DISP(2,18,LOW,'Die klassische parallele Schnittstelle besitzt ein unidirektionales Daten-',0);
   DISP(2,19,LOW,'register (nur Ausgabe), daher ist eine eventuelle Bidirektionalitt inkl.',0);
   DISP(2,20,LOW,'entsprechendem Steuerbit (im Controlregister) nicht bercksichtigt.',0);

   DISP(2,21,LOW,'Mittels F5 wird der Test aufgerufen. Am Pin2=D0 ndert sich der Pegel mit',0);
   DISP(2,22,LOW,'einer Frequenz von ca. 1Hz. Ist als einfache Hilfe beim Auffinden der',0);
   DISP(2,23,LOW,'Steckverbindung gedacht!',0);

   DISP(32,24,HIGH,'Zur Programmrckkehr bitte eine Taste drcken!',0);

   CursorOFF;
   repeat until keypressed;
   ch := readkey;
   CursorON;
   clrscr;
   FORMULAR;
end;
{ ------------------------------------------------------------------------- }


procedure TEST;

begin
   DISP(5,22,LOW,' ',74);
   DISP(23,22,HIGH,'Mit beliebiger Taste Test beenden!',0);
   DISP(4,3,LOW,'D',0);
   DISP(71,14,LOW,'R',0);
   DISP(58,14,LOW,'L',0);
   DISP(44,14,LOW,'I',0);
   DISP(31,14,LOW,'A',0);
   DISP(18,14,LOW,'S',0);

   CursorOFF;
   if AUTOFEEDPEGEL=HI then
      begin
         AUTOFEED;
         port[CtrlRegAdr] := CtrlReg;
      end;

   repeat
      if BITPEGEL(DatReg,NINV,0) = lo then DatReg := DatReg + 1
                                        else DatReg := DatReg - 1;
      DISPZUSTAND(38,5,INV,BITPEGEL(DatReg,NINV,0));
      DISP(5,5,LOW,ZahlToStr(DatReg,3),0);
      DISP(4,5,LOW,'$'+ ByteToHex(DatReg),4);
      DISP(8,5,LOW,DEZBIN(DatReg),0);

      port[DatRegAdr] := DatReg;
      Eingabe;  { Einlesen des Statusregisters und Anzeige aktualisieren }

      delay(499);
   until keypressed;

   ch := readkey;

   DISP(5,22,LOW,'<F1> Hilfe',74);
   DISP(35,22,LOW,'<F5> Test',0);
   DISP(67,22,LOW,'<F10> Ende',0);
end;
{ ------------------------------------------------------------------------- }




{ ------------------------------------------------------------------------- }
{ *********************** HAUPTPROGRAMM *********************************** }
{ ------------------------------------------------------------------------- }
begin
     LowVideo;
     TextBackground(Black);
     TextColor(LightGray);
     clrscr;

     { voreingestellte Werte bei Programmstart             }

     Start         := true;
     Ende          := false;

{     LPT           := 2;     { Nr. der parallelen Schnittstellen }
     DatReg        := $00;
     AdrOut        := $FF;
     DataOut       := $87;
     DataIn        := $FF;
     CtrlReg       := $00;
     DataInLSB     := $00;
     DataInMSB     := $00;

{     LPTs;

     DatRegAdr     := LPTadr[LPT];
     StatRegAdr    := DatRegAdr + 1;
     CtrlRegAdr    := DatRegAdr + 2;
}
     port[CtrlRegAdr] := CtrlReg;
     port[DatRegAdr]  := DatReg;

     FORMULAR;

     repeat

        CURSOROFF;
        repeat until keypressed;

        ch := readkey;
        Steuerchar := 0;
        if ch = #0 then   { Sondertaste, z. B. Funktionstaste }

        begin
           ch := readkey;
           Steuerchar := -ord(ch)
        end

        else  Steuerchar := +ord(ch);

        case Steuerchar of
            83, 115 : STROBE;                       { Taste S, s }
            65,  97 : AUTOFEED;                     { Taste A, a }
            73, 105 : INIT;                         { Taste I, i }
            76, 108 : SLCTIN;                       { Taste L, l }
            82, 114 : IRQENABLE;                    { Taste R, r }

            68, 100 : DATAneu;                      { Taste D, d }

                -59 : HILFE;                        { F1  Hilfe  }
                -63 : TEST;                         { F5  Test   }

                -68 : Ende:=true;                   { F10 Ende }
        end;

        port[CtrlRegAdr] := CtrlReg;
        port[DatRegAdr]  := DatReg;

        AUSGABE;
        STEUERREG;
        EINGABE;

     until Ende;

     DISP(1,1,LOW,' ',0);
     CURSORON;

     clrscr;

end.
