program LPTTEST1;

{ Hilfsprogramm zur Einzelansteuerung der Daten-, Steuer- und Statusleitungen
  der parallelen Schnittstelle

  CopyRight Helmut Berka, DL2MAJ, Dornbuschweg 11, 86836 Obermeitingen
  All Rights Reserved - Nichtkommerzielle Nutzung im Amateurfunk gestattet }

uses DOS, CRT, PRINTER, SUPPORT, CURSOR;

type Pegel       = (HI, lo, Er);
     PegelLage   = (INV_, NINV);
     str3        = string[3];

var Steuerchar,                          { Nummer der zuvor gedrckten Taste }
    LPT         : integer;               { Nummer der parallelen Schnittstelle }
    ch          : char;                  { gedrcktes Zeichen }
    Ende        : boolean;               { steuert Programmende, wenn wahr }
    LPTadr      : array[1 .. 4] of word; { Adressen der par. Schnittstellen als Zahl }
    DatRegAdr,                           { Adresse des Datenregisters }
    CtrlRegAdr,                          { Adresse des Controlregisters }
    StatRegAdr  : word;                  { Adresse des Statusregisters }
    DatReg,                              { Inhalt des Datenregisters }
    CtrlReg,                             { Inhalt des Controlregisters }
    StatReg        : byte;               { Inhalt des Statusregisters }

{ ------------------------------------------------------------------------- }
{ ------------------------------------------------------------------------- }



procedure LPTs; { sucht, findet und whlt parallele Schnittstelle aus }

var LPTZahl,                    { Anzahl der parallelen Schnittstellen }
    LPTZahlVorhanden : byte;    { Anzahl der parallelen Schnittstelle mit Adresse <> 0 }
    W                : string;  { Auswahlvariable }
    LPTadrStr        : array[1 .. 4] of string;  { Adressen der par. Schnittstellen als Zeichenfolge }
    i,                          { Laufvariable }
    SteuerZ          : integer; { Steuerzeichen fr Aktionen nach Eingaben }

begin
     LPTZahl := mem[$40:$11] shr 6;
     if LPTZahl = 0 then
        begin
           DISP(10,5,INV,'Keine parallele Schnittstelle vorhanden',0);
           halt;
        end
     else
        begin
           for i := 1 to LPTZahl do LPTadr[i]  := memw[$40:$06+(2*i)];

           LPTZahlVorhanden := LPTZahl;
           for i := 1 to LPTZahl do
              if LPTadr[i] = 0 then LPTZahlVorhanden := LPTZahlVorhanden - 1;
           LPTZahl := LPTZahlVorhanden;

           if LPTZahl = 1 then
           begin
              DISP(5,5,INV,'Nur 1 parallele Schnittstelle vorhanden !',0);
              DISP(5,7,INV,'Bitte einen an LPT1 angeschlossenen Drucker abstecken,',0);
              DISP(5,8,INV,'zum Schutz vor evtl. mglichen Beschdigung des Druckers,',0);
              DISP(5,9,INV,'da die parallele Schnittstelle nicht als Druckerschnittstelle',0);
              DISP(5,10,INV,'angesteuert wird (auch nicht bers BIOS).',0);
              DISP(5,12,HIGH,'Zum Fortfahren (=kein Drucker an LPT1) bitte  J  und <RETURN>',0);
              DISP(35,17,HIGH,'Zum Programmabbruch bitte <RETURN> eingeben',0);
              W := 'N';
              LIESLN(70,12,1,INV,W,SteuerZ);
              if W <> 'J' then halt;
              clrscr;
           end;

           DISP(3,2,HIGH,'Anzahl der parallelen Schnittstellen : ',0);
           DISP(42,2,HIGH,ZahlToStr(LPTZahl,1),0);

           for i := 1 to LPTZahl do

           begin
              DISP(10,3+i,HIGH,'Adresse von LPT' + ZahlToStr(i,1) + ' : ',0);
              DISP(52,3+i,HIGH,WordToHex(LPTadr[i]) + 'h',0);
           end;

           DISP(10,5+LPTZahl,HIGH,'Bitte whlen Sie : ',0);
           LPT := LPTZahl;
           LIESINT(32,5+LPTZahl,2,High,LPT,SteuerZ);

        end;
        clrscr;
end;
{ ------------------------------------------------------------------------- }


function BITPEGEL(Data:byte; Lage: PegelLage; BitNr: integer): str2;
{ Data : 8bit-Date, aus der ein Bit auszugeben ist
  Lage : INV_ oder NINV, je nachdem ob Ausgangssignal zu Registerinhalt
         invertiert oder nichtinvertiert ist
  BitNr: 0 .. 7, entsprechen Datenbits D0 .. D7                             }

begin
   BitNr := 8 - BitNr; { Bit0 ist LSB und steht ganz rechts = 8. Stelle }
   if ((BitNr < 1) or (BitNr > 8))
      then BITPEGEL := 'Er'
      else if Lage = INV_
              then if copy(DEZBIN(Data),BitNr,1) = '0'
                      then BITPEGEL := 'HI'
                      else BITPEGEL := 'lo'
              else if copy(DEZBIN(Data),BitNr,1) = '0'
                      then BITPEGEL := 'lo'
                      else BITPEGEL := 'HI';
end;
{ ------------------------------------------------------------------------- }


function STROBEPEGEL:str2;

begin
   STROBEPEGEL := BITPEGEL(CtrlReg,INV_,0);
end;
{ ------------------------------------------------------------------------- }


function AUTOFEEDPEGEL:str2;

begin
   AUTOFEEDPEGEL := BITPEGEL(CtrlReg,INV_,1);
end;
{ ------------------------------------------------------------------------- }


function INITPEGEL:str2;

begin
   INITPEGEL := BITPEGEL(CtrlReg,NINV,2);
end;
{ ------------------------------------------------------------------------- }


function SLCTINPEGEL:str2;

begin
   SLCTINPEGEL := BITPEGEL(CtrlReg,INV_,3);
end;
{ ------------------------------------------------------------------------- }


function IRQENABLEINHALT:str3;

begin
   if BITPEGEL(CtrlReg,NINV,4) = 'lo' then IRQENABLEINHALT := 'No '
                                      else IRQENABLEINHALT := 'Yes';
end;
{ ------------------------------------------------------------------------- }


procedure AUSGABE;   { Ausgabe des Datenregisters }

var j : integer;     { Laufvariable }

begin
   DISP(5,3,HIGH,'D',0);
   DISPR(24,3,LOW,LPT,2,0);
   DISP(6,3,LOW,'atenbyteinhalt LPT',0);
   DISP(25,3,LOW,':',0);

   DISP(5,4,LOW,'Dez Hex Binr',0);         { Anzeige dezimal, hexadezimal und binr }
   DISP(5,5,LOW,ZahlToStr(DatReg,3),0);     { Umwandlung und Anzeige dezimal }
   DISP(9,5,LOW,'$' + ByteToHex(DatReg),4); { Umwandlung und Anzeige hexadezimal }
   DISP(13,5,LOW,DEZBIN(DatReg),0);         { Umwandlung und Anzeige binr }

   DISP(38,5,LOW,'Pegel->',0);
   DISP(40,6,LOW,'Pin->',0);
   DISP(48,6,LOW,' 9  8  7  6  5  4  3  2',0);

   DISP(48,4,LOW,'D7 D6 D5 D4 D3 D2 D1 D0',0);
   for j:=1 to 8 do DISP(72-j*3,5,LOW,BITPEGEL(DatReg,NINV,j-1),0);

end;
{ ------------------------------------------------------------------------- }



procedure STEUERREG; { Ausgabe des Steuer- oder Controlregisters }

begin
   DISP(5,10,LOW,'Controlbyte',0);

   DISP(5,11,LOW,'Dez Hex Binr',0);        { Anzeige dezimal, hexadezimal und binr }
   DISP(5,12,LOW,ZahlToStr(CtrlReg,3),0);   { Umwandlung und Anzeige dezimal }
   DISP(9,12,LOW,'$'+ByteToHex(CtrlReg),0); { Umwandlung und Anzeige hexadezimal }
   DISP(13,12,LOW,DEZBIN(CtrlReg),0);       { Umwandlung und Anzeige binr }

   DISP(25,11,LOW,'I Qenable',0);
   DISP(26,11,HIGH,'R',0);
   DISP(28,12,LOW,IRQENABLEINHALT,0);       { IRQEnablel! }

   DISP(38,12,LOW,'Pegel->',0);

   DISP(40,13,LOW,'Pin->',0);
   DISP(48,13,LOW,' 1     14      16       17',0);

   DISP(46,10,LOW,'______',0);
   DISP(46,11,LOW,'S CTIN',0);
   DISP(47,11,HIGH,'L',0);
   DISP(48,12,LOW,SLCTINPEGEL,0);           { /SLCTIN-Pegel! }

   DISP(54,11,HIGH,'I',0);
   DISP(55,11,LOW,'nit',0);
   DISP(55,12,LOW,INITPEGEL,0);             { Init-Pegel! }

   DISP(60,10,LOW,'________',0);
   DISP(60,11,HIGH,'A',0);
   DISP(61,11,LOW,'utofeed' ,0);
   DISP(63,12,LOW,AUTOFEEDPEGEL,0);         { /AutoFeed-Pegel! }

   DISP(70,10,LOW,'______',0);
   DISP(70,11,HIGH,'S',0);
   DISP(71,11,LOW,'trobe',0);
   DISP(72,12,LOW,STROBEPEGEL,0);           { /Strobe-Pegel! }

end;
{ ------------------------------------------------------------------------- }


procedure FORMULAR;

begin
   RAHMEN(1,1,80,24,INV,false);          { Titel }
   DISP(12,1,INV,'   Testprogramm fr parallele Schnittstelle   ',0);
   DISP(62,1,LOW,' c DL2MAJ 1997 ',0);

   RAHMEN(2,2,79,7,HIGH,false);           { Rahmen fr Datenregister }
   DISP(8,2,HIGH,' Ausgabe (Datenregister) ',0);

   RAHMEN(2,9,79,14,HIGH,false);         { Rahmen fr Controlregister }
   DISP(8,9,HIGH,' Ausgabe (Controlregister) ',0);

   RAHMEN(2,16,79,21,HIGH,false);         { Rahmen fr Statusregister }
   DISP(8,16,HIGH,' Eingabe (Statusregister) ',0);

   AUSGABE;   { Anzeige des Datenregisterinhalts }
   STEUERREG; { Anzeige des Controlregisterinhalts }

   DISP(5,22,LOW,'<F1> Hilfe',0);
   DISP(35,22,LOW,'<F5> Test',0);
   DISP(67,22,LOW,'<F10> Ende',0);
   DISP(72,23,LOW,' LPT  ',0);
   DISPR(76,23,LOW,LPT,2,0);
end;
{ ------------------------------------------------------------------------- }


function SLCTPEGEL:str2;

begin
   SLCTPEGEL := BITPEGEL(StatReg,NINV,4);
end;
{ ------------------------------------------------------------------------- }


function PAPEREMPTYPEGEL:str2;

begin
   PAPEREMPTYPEGEL := BITPEGEL(StatReg,NINV,5);
end;
{ ------------------------------------------------------------------------- }


function ACKPEGEL:str2;

begin
   ACKPEGEL := BITPEGEL(StatReg,NINV,6);
end;
{ ------------------------------------------------------------------------- }


function BUSYPEGEL:str2;

begin
   BUSYPEGEL := BITPEGEL(StatReg,INV_,7);
end;
{ ------------------------------------------------------------------------- }


function ERRPEGEL:str2;

begin
   ERRPEGEL := BITPEGEL(StatReg,NINV,3);
end;
{ ------------------------------------------------------------------------- }


procedure EINGABE; { liest Inhalt des Statusregisters und aktualisiert Anzeige }

begin
   StatReg := port[StatRegAdr] and $F8;
   DISP(5,17,LOW,'Statusbyte',0);

   DISP(5,18,LOW,'Dez Hex Binr',0);          { Anzeige dezimal, hexadezimal und binr }
   DISP(5,19,LOW,ZahlToStr(StatReg,3),0);     { Umwandlung und Anzeige dezimal }
   DISP(9,19,LOW,'$' + ByteToHex(StatReg),0); { Umwandlung und Anzeige hexadezimal }
   DISP(13,19,LOW,DEZBIN(StatReg),0);         { Umwandlung und Anzeige binr }

   DISP(38,19,LOW,'Pegel->',0);

   DISP(40,20,LOW,'Pin->',0);
   DISP(47,20,LOW,' 15    11  10   12    13',0);

   DISP(47,17,LOW,'____',0);
   DISP(47,18,LOW,'Busy',0);
   DISP(48,19,LOW,BUSYPEGEL,0);               { /Busy-Pegel! }

   DISP(53,18,LOW,'ACK',0);
   DISP(54,19,LOW,ACKPEGEL,0);                { Acknoledge-Pegel! }

   DISP(58,18,LOW,'PE',0);
   DISP(58,19,LOW,PAPEREMPTYPEGEL,0);         { Paper Empty-Pegel! }

   DISP(62,18,LOW,'SLCT',0);
   DISP(63,19,LOW,SLCTPEGEL,0);               { Select-Pegel! }

   DISP(68,17,LOW,'   ',0);
   DISP(68,18,LOW,'Err',0);
   DISP(69,19,LOW,ERRPEGEL,0);                { /Error-Pegel! }

end;
{ ------------------------------------------------------------------------- }


procedure STROBE;  { invertiert Bit im Register }

begin
   if STROBEPEGEL = 'lo' then CtrlReg := CtrlReg - 1
                         else CtrlReg := CtrlReg + 1;
end;
{ ------------------------------------------------------------------------- }


procedure AUTOFEED;  { invertiert Bit im Register }

begin
   if AUTOFEEDPEGEL = 'lo' then CtrlReg := CtrlReg - 2
                           else CtrlReg := CtrlReg + 2;
end;
{ ------------------------------------------------------------------------- }


procedure INIT;  { invertiert Bit im Register }

begin
   if INITPEGEL = 'lo' then CtrlReg := CtrlReg + 4
                       else CtrlReg := CtrlReg - 4;
end;
{ ------------------------------------------------------------------------- }


procedure SLCTIN;   { invertiert Bit im Register }

begin
   if SLCTINPEGEL = 'lo' then CtrlReg := CtrlReg - 8
                         else CtrlReg := CtrlReg + 8;
end;
{ ------------------------------------------------------------------------- }


procedure IRQENABLE;  { invertiert Bit im Register }

begin
   if IRQENABLEINHALT = 'No ' then CtrlReg := CtrlReg + 16
                              else CtrlReg := CtrlReg - 16;
end;
{ ------------------------------------------------------------------------- }


procedure DATAneu;

var DatRegInt, SteuerZ   : integer;
    ok                   : boolean;

begin
   DISP( 5,3, LOW,'D',0);
   DISP(10,3,HIGH,'b',0);
   DISP(49,4,HIGH,'7',0);
   DISP(52,4,HIGH,'6',0);
   DISP(55,4,HIGH,'5',0);
   DISP(58,4,HIGH,'4',0);
   DISP(61,4,HIGH,'3',0);
   DISP(64,4,HIGH,'2',0);
   DISP(67,4,HIGH,'1',0);
   DISP(70,4,HIGH,'0',0);

   CursorOff;
   repeat until keypressed;
   CursorOn;

   ch := readkey;
   Steuerchar := 0;
   if ch = #0 then   { Sondertaste, z. B. Funktionstaste }

   begin
      ch := readkey;
      Steuerchar := -ord(ch)
   end

   else  Steuerchar := +ord(ch);

   case Steuerchar of
            48 : if BITPEGEL(DatReg,NINV,0) = 'lo'       { Taste 0 }
                    then DatReg := DatReg + 1
                    else DatReg := DatReg - 1;
            49 : if BITPEGEL(DatReg,NINV,1) = 'lo'       { Taste 1 }
                    then DatReg := DatReg + 2
                    else DatReg := DatReg - 2;
            50 : if BITPEGEL(DatReg,NINV,2) = 'lo'       { Taste 2 }
                    then DatReg := DatReg + 4
                    else DatReg := DatReg - 4;
            51 : if BITPEGEL(DatReg,NINV,3) = 'lo'       { Taste 3 }
                    then DatReg := DatReg + 8
                    else DatReg := DatReg - 8;
            52 : if BITPEGEL(DatReg,NINV,4) = 'lo'       { Taste 4 }
                    then DatReg := DatReg + 16
                    else DatReg := DatReg - 16;
            53 : if BITPEGEL(DatReg,NINV,5) = 'lo'       { Taste 5 }
                    then DatReg := DatReg + 32
                    else DatReg := DatReg - 32;
            54 : if BITPEGEL(DatReg,NINV,6) = 'lo'       { Taste 6 }
                    then DatReg := DatReg + 64
                    else DatReg := DatReg - 64;
            55 : if BITPEGEL(DatReg,NINV,7) = 'lo'       { Taste 7 }
                    then DatReg := DatReg + 128
                    else DatReg := DatReg - 128;

       66,  98 : begin                                   { Taste b }
                    DatRegInt := DatReg;
                    DISP(5,4,HIGH,'Dez',0);

                    repeat
                       ok := true;
                       LIESINT(5,4,4,HIGH,DatRegInt,SteuerZ);
                       if ((DatRegInt<0) or (DatRegInt>255)) then
                       begin
                          ok := false;
                          DatRegInt := DatReg;
                          DISP(3,6,INV,' nur 0 .. 255 mglich! ',0);
                          BEEP(2000,100);
                       end;
                    until ok;
                    DISP(3,6,HIGH,'                       ',0);

                    DatReg := DatRegInt;
                 end;
   end;
end;
{ ------------------------------------------------------------------------- }


procedure HILFE;

begin
   clrscr;
   DISP(2,1,LOW,'Die Inhalte der Register werden mit log. 0 bzw. log. 1 dargestellt,',0);
   DISP(2,2,LOW,'die an der Schnittstelle mebaren bzw. anliegenden Signale werden',0);
   DISP(2,3,LOW,'als lo bzw. HI-Pegel (entspricht niedriger bzw. hoher Spannung)',0);
   DISP(2,4,LOW,'angezeigt. Invertierte Signale sind durch einen Querstrich oberhalb',0);
   DISP(2,5,LOW,'des Signalnamens gekennzeichnet.',0);

   DISP(2,6,LOW,'Eine bitweise Vernderung (Invertierung) der Registerinhalte wird durch',0);
   DISP(2,7,LOW,'Eingabe des fett gedruckten Zeichens erreicht. Das Datenregister kann',0);
   DISP(2,8,LOW,'nach Eingabe von D und b durch einen Dezimalwert byteweise als auch durch',0);
   DISP(2,9,LOW,'Eingabe von D und 0 .. 7 bitweise verndert werden.',0);

   DISP(2,10,LOW,'Im Control- und Statusregister sind nicht alle Bits belegt, beim Ein-',0);
   DISP(2,11,LOW,'lesen bzw. bei der Ausgabe werden die unbenutzten Bits (Control-',0);
   DISP(2,12,LOW,'register D7 .. D5, Statusregister D2 .. D0) mit log. 0 belegt (durch',0);
   DISP(2,13,LOW,'UND-Verknpfung mit $1F bzw. $F8).',0);
   DISP(2,14,LOW,'Eine Sonderstellung nimmt D4 des Controlregisters ein. Diesem Bit ist keine',0);
   DISP(2,15,LOW,'Leitung am Schnittstellenausgang zugeordnet. Der Inhalt bestimmt, ob ber die',0);
   DISP(2,16,LOW,'Acknowledge-Leitung eine Interruptanforderung ausgelst werden darf',0);
   DISP(2,17,LOW,'(log. 1 = Yes, log. 0 = No).',0);

   DISP(2,18,LOW,'Die klassische parallele Schnittstelle besitzt ein unidirektionales Daten-',0);
   DISP(2,19,LOW,'register (nur Ausgabe), daher ist eine eventuelle Bidirektionalitt inkl.',0);
   DISP(2,20,LOW,'entsprechendem Steuerbit (im Controlregister) nicht bercksichtigt.',0);

   DISP(2,21,LOW,'Mittels F5 wird der Test aufgerufen. Am Pin2=D0 ndert sich der Pegel mit',0);
   DISP(2,22,LOW,'einer Frequenz von ca. 1Hz. Ist als einfache Hilfe beim Auffinden der',0);
   DISP(2,23,LOW,'Steckverbindung gedacht!',0);

   DISP(32,24,HIGH,'Zur Programmrckkehr bitte eine Taste drcken!',0);

   CursorOFF;
   repeat until keypressed;
   ch := readkey;
   CursorON;

   clrscr;
   FORMULAR;
end;
{ ------------------------------------------------------------------------- }


procedure TEST;

begin
   DISP(5,22,LOW,' ',74);
   DISP(23,22,HIGH,'Mit beliebiger Taste Test beenden!',0);
   DISP(5,3,LOW,'D',0);
   DISP(26,11,LOW,'R',0);
   DISP(47,11,LOW,'L',0);
   DISP(54,11,LOW,'I',0);
   DISP(60,11,LOW,'A',0);
   DISP(70,11,LOW,'S',0);

   CursorOFF;
   repeat
      if BITPEGEL(DatReg,NINV,0) = 'lo' then DatReg := DatReg + 1
                                        else DatReg := DatReg - 1;
      DISP(69,5,INV,BITPEGEL(DatReg,NINV,0),0);
      DISP(5,5,LOW,ZahlToStr(DatReg,3),0);
      DISP(9,5,LOW,'$'+ ByteToHex(DatReg),0);
      DISP(13,5,LOW,DEZBIN(DatReg),0);

      port[DatRegAdr] := DatReg;
      Eingabe;  { Einlesen des Statusregisters und Anzeige aktualisieren }

      delay(499);
   until keypressed;

   ch := readkey;

   DISP(5,22,LOW,'<F1> Hilfe',74);
   DISP(35,22,LOW,'<F5> Test',0);
   DISP(67,22,LOW,'<F10> Ende',0);
end;
{ ------------------------------------------------------------------------- }



{ ------------------------------------------------------------------------- }
{ *********************** HAUPTPROGRAMM *********************************** }
{ ------------------------------------------------------------------------- }
begin
     LowVideo;
     TextBackground(Black);
     TextColor(LightGray);
     clrscr;

     { voreingestellte Werte bei Programmstart             }
     Ende          := false;
     LPT           := 2;     { Nr. der parallelen Schnittstellen }

     LPTs;  { Feststellen von Anzahl und Adressen der parallen Ports im PC }

     DatRegAdr     := LPTadr[LPT];
     StatRegAdr    := DatRegAdr + 1;
     CtrlRegAdr    := DatRegAdr + 2;

     DatReg  := port[DatRegAdr];
     CtrlReg := port[CtrlRegAdr] and $1F; { Bit D7 .. D5 sind unbenutzt }

     FORMULAR;


     repeat

        CursorOff;
        repeat
           EINGABE; { Einlesen des Statusregisters und Anzeige aktualisieren }
        until keypressed;
        CursorOn;

        ch := readkey;
        Steuerchar := 0;
        if ch = #0 then   { Sondertaste, z. B. Funktionstaste }

        begin
           ch := readkey;
           Steuerchar := -ord(ch)
        end

        else  Steuerchar := +ord(ch);

        case Steuerchar of
            83, 115 : STROBE;                       { Taste S, s }
            65,  97 : AUTOFEED;                     { Taste A, a }
            73, 105 : INIT;                         { Taste I, i }
            76, 108 : SLCTIN;                       { Taste L, l }
            82, 114 : IRQENABLE;                    { Taste R, r }

            68, 100 : DATAneu;                      { Taste D, d }

                -59 : HILFE;                        { F1  Hilfe  }
                -63 : TEST;                         { F5  Test   }
                -68 : Ende:=true;                   { F10 Ende   }
        end;

        port[CtrlRegAdr] := CtrlReg;
        port[DatRegAdr]  := DatReg;

        AUSGABE;
        STEUERREG;

     until Ende;

     DISP(1,1,LOW,' ',0);
     clrscr;

end.
