program GEWITTER;

{ Programm zum Auslesen des Gewitter-RX Version 1 mit dem LPT-Interface
  ber die parallele Schnittstelle

  CopyRight Helmut Berka, DL2MAJ, Dornbuschweg 11, 86836 Obermeitingen
  All Rights Reserved - Nichtkommerzielle Nutzung im Amateurfunk gestattet }

uses DOS, CRT, PRINTER, SUPPORT, CURSOR, LPTUNIT;

type str3  = string[3];
     str10 = string[10];
     str24 = string[24];
     str47 = string[47];

var Steuerchar                      : integer;
    j                               : longint;
    Jahr, Monat, Tag, WoTag         : word;
    ch                              : char;
    Ende, Start                     : boolean;
    Schleifenzeit                   : real;
    DataIn, Staerke                 : byte;
    DataInLSB, DataInMSB            : byte;
    DatumAlt, DatumNeu              : str10;
    TagStr, MonatStr, PegelStr      : str2;
    JahrStr                         : str4;
    filename                        : str8;



procedure FORMULAR;

begin
     RAHMEN(1,1,80,24,INV,false);          { Titel }
     DISP(12,1,INV,'   Demoprogramm fr Gewitter-RX-Abfrage   ',0);
     DISP(62,1,LOW,' c DL2MAJ 1999 ',0);

     RAHMEN(2,8,79,12,HIGH,false);         { Rahmen fr Anzeige }
     DISP(8,8,HIGH,' Blitzereignisse ',0);
     DISP( 3,9,LOW,'ERROR',0);
     DISP(10,9,LOW,'Datum',0);
     DISP(23,9,LOW,'Uhrzeit',0);
     DISP(50,9,LOW,'Strke',0);
     DISP(72,9,LOW,'waits',0);

     Staerke := LPTin(14,0);

     DISP(5,22,LOW,'<F1> Hilfe',74);
     DISP(20,22,LOW,'<F3> Reset',0);
     DISP(35,22,LOW,'<F5> Test',0);
     DISP(67,22,LOW,'<F10> Ende',0);
     DISP(72,23,LOW,' LPT  ',0);
     DISPR(76,23,LOW,LPT,2,0);
     DISP(72,24,LOW,' V 0600 ',0);
end;
{ ------------------------------------------------------------------------- }


function GEWITTERSTAERKE : byte;

var Wert     : byte;

begin
   AUSWAHL(14,0);
   SLCTIN(lo);
   DataIn := (port[StatRegAdr] shr 4) and $0F;
   SLCTIN(HI);
   Wert := (DataIn + (port[StatRegAdr] and $F0)) and $7F;
{   DISPR(10,10,HIGH,Wert,5,0);}
   GEWITTERSTAERKE := Wert;
end;
{ ------------------------------------------------------------------------- }


procedure NULL;

begin
   AUSWAHL(14,0);
   STROBE(HI);
   STROBE(lo);
   STROBE(HI);
   delay(15);
   STROBE(lo);
   STROBE(HI);
   DISPR(51,11,HIGH,GEWITTERSTAERKE,5,0);
end;
{ ------------------------------------------------------------------------- }


procedure MESSUNG;

var h, m, s, s100_alt, s100_neu              : word;
    s100, s100_int                           : integer;
    s1000                                    : real;
    hStr, mStr, sStr                         : str2;
    S100Str                                  : str3;
    s1000Str                                 : str10;
    DatumNeu                                 : str10;
    ZeitStr                                  : str24;
    j                                        : integer;
    Ereignis                                 : str47;
    StaerkeStr                               : str4;
    GewitInfo                                : text;

begin
   gettime(h, m, s, s100_neu);
   s100_int:=10*s100_neu;
   if s100_neu=s100_alt
      then s100:=s100+11
      else begin s100_alt:=s100_neu; s100:=s100_int; end;

{   s1000:=(((h*60)+m)*60+s)*1000+s100;   }
   s1000:=h*60+m;
   s1000:=s1000*60+s;
   s1000:=s1000*1000+s100;
   s1000:=s1000/(3600*1000);

   str(h, hStr);
   if length(hStr)=1 then hStr:='0' + hStr;
   str(m, mStr);
   if length(mStr)=1 then mStr:='0' + mStr;
   str(s, sStr);
   if length(sStr)=1 then sStr:='0' + sStr;
   str(s100, s100Str);
   while length(s100Str)<3 do s100Str:='0' + s100Str;
   str(s1000:10:6, s1000Str);

   getdate(Jahr, Monat, Tag, WoTag);
   str(Jahr, JahrStr);
   str(Monat, MonatStr);
   if length(MonatStr)=1 then MonatStr:='0' + MonatStr;
   str(Tag, TagStr);
   if length(TagStr)=1 then TagStr:='0' + TagStr;
   DatumNeu := JahrStr + '/' + MonatStr + '/' + TagStr;
   ZeitStr := hstr + ':' + mStr + ':' + sStr + ':'
                   + s100Str + '  ' + s1000Str;
   if DatumNeu <> DatumAlt then filename := JahrStr + MonatStr + TagStr;

   j := 0;
   repeat
      j := j+1;
   until (BITPEGEL(port[StatRegAdr],NINV,3) = lo);

   Staerke := GEWITTERSTAERKE;

   STROBE(lo); STROBE(lo);
   STROBE(HI); STROBE(HI);
   STROBE(lo); STROBE(lo);
   STROBE(HI);

   assign(GewitInfo,'c:\Gewitter\'+filename+'.GEW');
   (*$I-*)
   reset(GewitInfo);
   (*$I+*)
   if ioresult <> 0 then
      begin
         rewrite(GewitInfo);
         writeln(GewitInfo,'Datum        Uhrzeit        in h          Staerke');
      end;

   append(GewitInfo);

   str(Staerke,StaerkeStr);
   Ereignis := DatumNeu+' @ '+ZeitStr+'  =  '+StaerkeStr;

   writeln(GewitInfo,Ereignis);

   close(GewitInfo);

{   writeln(Ereignis, '     ', j);}
   DISP(10,10,HIGH,DatumNeu,10);
   DISP(23,10,HIGH,ZeitStr,11);
   DISP(51,10,HIGH,StaerkeStr,10);
   DISP(47,11,HIGH,'            ',0);
   DISPR(70,10,HIGH,j,6,0);
end;
{ ------------------------------------------------------------------------- }


procedure HILFE;

begin
   clrscr;
   DISP(2,1,LOW,'In der ersten Spalte wird der aktuelle Status der ERROR-Leitung,',0);
   DISP(2,2,LOW,'angezeigt (bei Blitzereignis wird ein HI ausgegeben).',0);
   DISP(2,4,LOW,'Die zweite Spalte enthlt das Datum im Format JJJJ/MM/TT,',0);
   DISP(2,6,LOW,'in der dritten Spalte steht die Uhrzeit im Format hh:mm:ss:xx, wobei',0);
   DISP(2,7,LOW,'xx fr 1/100sec steht (Vorsicht! Auf meinem Bastel-PC, ein 486DX2-66,',0);
   DISP(2,8,LOW,'wird die Hundertstel-sec nur alle 50-60msec gendert!)',0);
   DISP(2,10,LOW,'In der Spalte nach dem Gleichheitszeichen steht der aus dem Gewitter-',0);
   DISP(2,11,LOW,'RX ausgelesene Wert fr die Strke (0 .. 127).',0);
   DISP(2,13,LOW,'Die Zahl rechts davon gibt die Anzahl der Warteschleifen an, die',0);
   DISP(2,14,LOW,'das Programm gedreht hat, ehe die ERROR-Leitung wieder auf lo',0);
   DISP(2,15,LOW,'geschaltet wurde, und damit das Auslesen starten konnte. Dieser Wert',0);
   DISP(2,16,LOW,'wird nicht abgespeichert.',0);
   DISP(2,18,LOW,'In einer Datei werden max. die Blitzereignisse eines Tages gespeichert,',0);
   DISP(2,19,LOW,'der Dateiname enthlt das Datum in der Form JJJJMMTT.GEW.',0);
   DISP(2,20,LOW,'  ',0);

   DISP(2,21,LOW,'Mittels F3 kann der Zhlerinhalt manuell rckgesetzt werden.',0);
   DISP(2,22,HIGH,'Das Programm steuert die /Sel14-Leitung an, der Jumper ist entsprechend',0);
   DISP(2,23,HIGH,'zu setzen.  ',0);

   DISP(32,24,HIGH,'Zur Programmrckkehr bitte eine Taste drcken!',0);

   CursorOFF;
   repeat until keypressed;
   ch := readkey;
   CursorON;

   clrscr;
   FORMULAR;
end;
{ ------------------------------------------------------------------------- }


{ ------------------------------------------------------------------------- }
{ *********************** HAUPTPROGRAMM *********************************** }
{ ------------------------------------------------------------------------- }
begin
     LowVideo;
     TextBackground(Black);
     TextColor(LightGray);
     clrscr;

     { voreingestellte Werte bei Programmstart             }

     Start         := true;
     Ende          := false;

{     LPT           := 2;     { Nr. der parallelen Schnittstellen }
     DatReg        := $00;
     AdrOut        := $FF;
     DataOut       := $87;
     DataIn        := $FF;
     CtrlReg       := $00;
     DataInLSB     := $00;
     DataInMSB     := $00;

     AUSWAHL(14,0);

     getdate(Jahr, Monat, Tag, WoTag);
     str(Jahr, JahrStr);
     str(Monat, MonatStr);
     if length(MonatStr)=1 then MonatStr:='0' + MonatStr;
     str(Tag-1, TagStr);
     if length(TagStr)=1 then TagStr:='0' + TagStr;
     DatumAlt := JahrStr + '.' + MonatStr + '.' + TagStr;

     FORMULAR;

     repeat

        CURSOROFF;
        repeat
           if BITPEGEL(port[StatRegAdr],NINV,3) = HI then
              begin
                 MESSUNG;
                 PegelStr := 'HI';
              end
           else PegelStr := 'lo';
           DISP(3,10,HIGH,PegelStr,0);
        until keypressed;

        ch := readkey;
        Steuerchar := 0;
        if ch = #0 then   { Sondertaste, z. B. Funktionstaste }

        begin
           ch := readkey;
           Steuerchar := -ord(ch)
        end

        else  Steuerchar := +ord(ch);

        case Steuerchar of
                -59 : HILFE;                        { F1  Hilfe  }
                -61 : NULL;                        { F3  Reset  }
                -63 : TEST;                         { F5  Test   }

                -68 : Ende:=true;                   { F10 Ende }
        end;

     until Ende;

     DISP(1,1,LOW,' ',0);
     CURSORON;

     clrscr;

end.
